﻿//sync font end
var SyncFontEnd = function(){
	this.init();
}
SyncFontEnd.prototype = {
	init:function(){
		var self = this,
		pageKind = document.body.id, //body id 指示当前显示页面
		comMatch={login:'loginInit',mainPane:'mainPaneInit',set:'setPaneInit'};//各页面初始化函数
		self.bg = chrome.extension&&chrome.extension.getBackgroundPage&&chrome.extension.getBackgroundPage();
		//self.addEvent(window,'selectstart',function(e){e.preventDefault();return false;});//禁止滑选
		if(pageKind){self[comMatch[pageKind]]();}
		else{self.mainPaneInit();}
		//self.loginInit();
		//self.mainPaneInit();
		//self.setPaneInit();
	},
	loginInit:function(){  //登陆处理逻辑
	   var self = this,
			mainBox = this.$('mainAreaOut'),
			accountBox = this.$('dolphinAccount'),
			hitIntBox = this.$('hitInBox'),
			respErrBox = this.$('showLoginErr'),
			loadCover = this.$('loadCover'),
			loginBtn = this.$('loginBtn'),
			accountElems = {},
			accountError = '',
			i=0,
			errorTypes = ['email', 'password', 'passworderror'],
			inputSets = {
				'email': [ 
					'Email', 
					[
						[1, /^(([^<>()[\]\\.,;:\s@\"]+(\.[^<>()[\]\\.,;:\s@\"]+)*)|(\".+\"))@((\[[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}\])|(([a-zA-Z\-0-9]+\.)+[a-zA-Z]{2,}))$/],
					],
					['@gmail.com', '@hotmail.com', '@yahoo.com', '@msn.com']
				],
				'password':[
					'Password',
					[
						[0, /[^\!\@\#\$\%\^\&\*\(\)_+-=\[\]\{\}\\;\|\':\",.<>\/?0-9a-zA-Z]/g],
						[0, /^.{0,5}$/]
					]
				]
			};
		self.resize(748,359);
		for(i in inputSets){ //初始化登陆变量及email hitin参数
			accountElems[i] = {'node':self.$('input[name="'+i+'"]','querySelectorAll')[0], 'placeholder':inputSets[i][0], 'regex':inputSets[i][1], 'value': ''};
			if(inputSets[i][2]){
				accountElems[i].node.addEventListener('input', accountEventHandle.bind(this, 'change'), true);
				accountElems[i].hotInt = []
				var hotins = inputSets[i][2];
				for(var j in hotins){
					var tmpHotin = document.createElement('div');
					tmpHotin.id = hotins[j];
					tmpHotin.className = 'hitInItem';
					tmpHotin.textContent = hotins[j];
					hitIntBox.appendChild(tmpHotin);
					accountElems[i].hotInt.push({'node': tmpHotin, 'text': hotins[j]});
				}
			}
		}
		accountElems['email'].node.focus();
		//if(!navigator.onLine){showErr('netOffline');}
		mainBox.addEventListener('click',accountEventHandle.bind(this, 'outerClick'), false);
		['mousedown', 'click', 'keydown', 'focus', 'blur'].forEach(function(item){
			accountBox.addEventListener(item, accountEventHandle.bind(self, item), true);
		}); // 监听海豚帐号登陆表单内事件
		function accountEventHandle(types, e){
		 	var targetElem = e.target;
		 	e.stopPropagation();
		 	switch(types){
		 		case 'mousedown':
		 			if(/hitInItem/.test(targetElem.className)){
		 				accountElems['email'].node.value = accountElems['email'].node.value + targetElem.id;
		 			}
		 		break;
		 		case 'outerClick':
					if(targetElem.tagName.toLowerCase() == 'b'){ //为正确捕获三方登陆点击hack
						targetElem = targetElem.parentNode; 
					}
					var tmpId = targetElem.id;

					if(tmpId=='backBtn'){
						setErrFlag('none');
						mainBox.className = mainBox.className.replace('dolphinLoginBox', '');
						self.bg.track_event({category:'general',action:'login',label:'account',value:1});
						return;
					}
					if(tmpId == 'dolphinLogin'){
						mainBox.className += ' dolphinLoginBox';
						return ;
					}
					if(/(\bfacebook\b)|(\bgoogle\b)/.test(tmpId)){
						self.bg.thirdParty_login(tmpId,window); //第三方登陆
					}
		 		break;
		 		case 'click':
		 			if(targetElem.id == 'loginBtn'){
		 				if(accountError in errorTypes){ //错误检查
		 					return ;
		 				}
		 				for(i in accountElems){
		 					if(accountElems[i].value == ''){ //非空检查
		 						setErrFlag(i);
		 						return;
		 					}
		 				}
		 				startLogin(accountElems.email.value, accountElems.password.value);
		 				return ;
		 			}
		 			if(/wrongInfoStyle (email|password)/.test(targetElem.className)){ //点击错误提示对应input获得焦点
		 				try{
		 					accountElems[RegExp.$1].node.focus();
		 				}catch(err){
		 					window.console.error(err);
		 				}
		 				return ;
		 			}
		 		break;
		 		case 'focus':
		 			var tmpName = targetElem.name,
		 				tmpElem = accountElems[tmpName];
		 			
		 			if(tmpElem){
		 				if(accountError == 'email' && tmpName == 'password'){ // email输入不合法，password不能获取焦点
		 					accountElems.email.node.focus();
		 					return ;
		 				}
		 				targetElem.className = targetElem.className + ' focus';
		 				targetElem.setAttribute('placeholder','')
		 				if(accountError != ''){
		 					setErrFlag('none');
		 				}
		 				if(tmpElem.hotInt && tmpElem.hotInt.length > 0 && targetElem.value && targetElem.value.indexOf('@') == -1){
			 				hitIntBox.style.display = 'block';
			 			}
		 			}
		 		break;
		 		case 'blur':
		 			var tmpName = targetElem.name,
		 				tmpElem = accountElems[tmpName],
		 				tmpValue,
		 				tmpValid = true;
		 				targetElem.className = 'accountInput';
		 			if(tmpElem && !(accountError == 'email' && tmpName == 'password')){
		 				targetElem.setAttribute('placeholder', tmpElem.placeholder);
		 				tmpValue = targetElem.value;
		 				tmpValid = tmpElem.regex.every(function(item){ // 输入正则检验（email,password）
		 					return item[0] ? item[1].test(tmpValue): !(item[1].test(tmpValue)); //为适配正则某些情况匹配正确，某些情况匹配错误hack
		 				});
		 				if(!tmpValid){
		 					setErrFlag(tmpName);
		 				}
		 				tmpElem.value = tmpValue;
		 			}
		 			if(tmpElem.hotInt&&tmpElem.hotInt.length>0){
		 				hitIntBox.style.display = 'none';
		 			}
		 		break;
		 		case 'keydown':
		 			if(e.keyCode == 13){  //把回车当tab用，烂！
		 				e.preventDefault();
						e.stopPropagation();
		 				targetElem.blur();
		 				if(accountBox.getAttribute('error') == 'none'){
		 					if(targetElem.name == 'password'){
		 						loginBtn.click();
		 					}else{
		 						accountElems.password.node.focus();
		 					}
		 				}
		 			}
		 		break;
		 		case 'change':
		 			if(targetElem.value && targetElem.value.indexOf('@') == -1){ //hitin逻辑
		 				var tmpName = targetElem.name,
			 				tmpElem = accountElems[tmpName];
			 			if(tmpElem.hotInt&&tmpElem.hotInt.length>0){
			 				hitIntBox.style.display = 'block';
			 				tmpElem.hotInt.forEach(function(item){
			 					item.node.textContent = targetElem.value + item.text;
			 				});
			 			}

		 			}else if(hitIntBox.style.display != 'none'){
		 				hitIntBox.style.display = 'none';
		 			}
		 			
		 		break;
		 		default:
		 	}
		}
		function setErrFlag (err_flag) {
			accountError = err_flag;
			accountBox.setAttribute('error', err_flag);
		}
		function startLogin(userName,userPw){  //开始登陆
			showloging(true);
			self.bg.dolphin_login(userName,userPw,showloging,function(errInfo){
				showloging(false);
				setErrFlag('passworderror');
				respErrBox.textContent = errInfo;
			},window);
		}
		function showloging(method){ //正在登陆 遮罩
			loadCover.style.display = method ? 'block' : 'none';
		} 
	},
	mainPaneInit:function(){  //主面板处理逻辑
	//if(!this.bg.CommInfo.is_login){chrome.browserAction.setPopup({popup:'login.html'});window.location.href="login.html";return ;}
	var self = this,curPage,syncLastOpen,mainHolder,syncList,outerHolder,enableViewOther=false,os;
		if(self.bg.CommInfo.is_login){
				self.bg.CommInfo.popup_id = this;
		}
		addListen();
		//ajaxGet('GET','http://offlinejs.com/online.php?r=0.7693329465109855',true,null,function(){
		//	netDisconnet();
		//	return ;
		//});
		self.reflashPage = function(devices,shortCut,kind){
			switch(kind){
				case 'push':
					if(curPage=='device'){
						createPageDom(devices,shortCut,'device');
					}
				break;
				case 'sync':
					if(curPage=='sync'){
						createPageDom(devices,null,'sync');
					}
				break;
			}
			return ;
		}
				
		self.sync_bookmark = function(status){
			var tmp = self.$('syncBookmark').className;
			switch(status){
				case 'doing':
					/disabled/.test(tmp)?'':(self.$('syncBookmark').className=tmp+' disabled');
				break;
				case 'disabled':
					self.$('syncBookmark').style.display='none';
				break;
				default:
					self.$('syncBookmark').className=tmp.replace(/disabled/,'')
				break;
			}
			return ;
		}
		function netDisconnet(){
			self.$('mainPaneOuter').className+=' noNet';
			self.$('mainPaneOuter').setAttribute('type','');
			var tmpNode = self.$('pageHolder'),outerHolder = self.$('mainPaneOuter');
			tmpNode.className = '';
			tmpNode.textContent = '';
			self.ff_createDom(tmpNode,{span:{inner:{p:{inner:'Network Error!'},'textNode':'Please check your connection.'}}});
			self.resize(outerHolder.offsetWidth,outerHolder.offsetHeight);
			tmpNode.style.overflowY='hidden';
		}
		function ajaxGet(tmpMethod,tmpUrl,tmpSync,sucFun,errFun){
			var xmlhttp;
			tmpMethod=tmpMethod?tmpMethod:'GET';
			tmpSync=tmpSync?tmpSync:true;
			if (window.XMLHttpRequest)
			  {// code for IE7+, Firefox, Chrome, Opera, Safari
			  xmlhttp=new XMLHttpRequest();
			  }
			else
			  {// code for IE6, IE5
			  xmlhttp=new ActiveXObject("Microsoft.XMLHTTP");
			  }
			xmlhttp.onreadystatechange=function()
			  {
				  if (xmlhttp.readyState==4){
					if(xmlhttp.status==200){
						if(sucFun){
							sucFun(xmlhttp.responseText);
							return ;
						}
					}else{
						if(errFun){
							errFun();
							return ;
						}
					}	
				 }
			  }
			xmlhttp.open(tmpMethod,tmpUrl,tmpSync);
			xmlhttp.send();
		}
		function addListen(){
			if(!(mainHolder=self.$('pageHolder'))){window.setTimeout(addListen,500);return ;}
			outerHolder = self.$('mainPaneOuter');
			self.addEvent(outerHolder,'click',function(e){handleClick(e)}); //委托所有click事件
			curPage = 'device'; //当前所在页面 device sync
			syncLastOpen=0; //记录tab 上一次展开位置 默认为第一个
			//self.$('showUserInfo').textContent= self.bg.CommInfo.nick_name;  //主面析显示用户名
			createPageDom(self.bg.GetPushDevicesSorted(),self.bg.CommInfo.get_device_shortcut(),'device');
			self.addEvent(window,'unload',function(){self.bg.CommInfo.popup_id = null;});	//关闭主面板时清空后台调用前端的接口
			//加载时viewOther 默认不可点
		}
		function secAddListen(){  //获取sync 大标题结点，用于只显示一下展开
			if(!(syncList=document.querySelectorAll('.syncListItem'))){window.setTimeout(secAddListen,500);return ;}
		}
		function createPageDom(data,shortCut,kind){  //组织页面之前的判断
			outerHolder.setAttribute('type',((kind=='device')?'showDevice':'showSync'));
			if(kind=='sync'){
				var tmpLocal = self.bg.CommInfo.get_setting(); //获取设置
				
				curPage = 'sync';
				if(tmpLocal){  //判断是否允许打开tab
					if(!tmpLocal['tab']){showErr('syncOpps');return ;}
				}
				if(data&&data.length>0){hasDeviceTreat(data,shortCut,false);return;} //有数据正常显示 
				showErr('syncNoDevice'); //无数据显示没有设备
			}else{ 
				curPage = 'device';
				//console.log('is connect :'+self.bg.pusher.isConnect());
				if(self.bg.pusher != null&&self.bg.pusher.isConnect() == true){  //判断是否已连接 没有的话保持正在加载
					chrome.tabs.query({highlighted:true, windowId: chrome.windows.WINDOW_ID_CURRENT}, function(tabs){  //判断是否是无意义的tab
						tab = tabs[0];
						if((tab && (tab.url.indexOf("http://") == -1 && tab.url.indexOf("https://") == -1))){
							viewOtherTreat(true);
							showErr('sentEmpty');  //只能本地打开 不可发送
						}else{
							if(data&&data.length>0){viewOtherTreat(true);hasDeviceTreat(data,shortCut,true);return;}  //正常显示
							showErr('downDolphin');  //无设备 显示下载海豚 可发送
						}
					});	
				}else{
					mainHolder.className="loadDevice";  //正在加载样式
					mainHolder.textContent = '';
					mainHolder.appendChild(document.createElement('span'));
					self.resize(outerHolder.offsetWidth,outerHolder.offsetHeight);
					//setTimeout(function(){self.resize(outerHolder.offsetWidth,outerHolder.offsetHeight)},50);
					mainHolder.style.overflowY='auto';
					self.bg.pushReConnect();
					/*setTimeout(function(){if(!self.bg.pusher.isConnect()){
						ajaxGet('GET','http://offlinejs.com/online.php?r=0.7693329465109855',true,null,function(){
							netDisconnet();
							return ;
						});
					}},1000);
					*/
				}
			}
			
		}
		function hasDeviceTreat(data,shortCutList,isDevice){ 
			var tmpHtml={},tmpList=[],tmp,Width=[250,185,155,130,100];
			if(isDevice){  //组织 device 
				tmpHtml.div = [];
				for(var i=0,len = data.length;i<len;i++){ // 每一项
					tmp = data[i];
					if(tmp){
					//tmpHtml.push('<div class="deviceItem" id="'+tmp.did+'"><a class="deviceItemInner '+(tmp.category||"pc")+((i==len-1)?" noBorder":"")+'" id="'+tmp.did+'">'+((shortCutList&&shortCutList[tmp.did])?'<span class="deviceName" style="width:'+Width[(shortCutList[tmp.did].length-1)]+'px">Send to '+(tmp.deviceName||'Siliver Pc')+'</span><span class="deviceShorcut">'+shortCutList[tmp.did].join('+'):'<span class="deviceName">Send to '+(tmp.deviceName||'Siliver Pc')+'</span><span class="deviceShorcut">')+'</span></a></div>')
					tmpHtml.div[i]={attr:{'class':'deviceItem',id:tmp.did},inner:{a:{attr:{'class':'deviceItemInner '+(tmp.category||"pc")+(tmp.state&&tmp.state==1?'_on':'')+((i==len-1)?" noBorder":""),id:tmp.did},inner:((shortCutList&&shortCutList[tmp.did])?{span:[{attr:{'class':'deviceName','style':"width:"+Width[(shortCutList[tmp.did].length-1)]+"px"},inner:'Send to '+tmp.deviceName||'Siliver Pc'},{attr:{'class':'deviceShorcut'},inner:shortCutList[tmp.did].join('+')}]}:{span:[{attr:{'class':'deviceName'},inner:'Send to '+(tmp.deviceName||'Siliver Pc')},{attr:{'class':'deviceShorcut'}}]})}}};
					}else{continue};
				}
				if(len>5){  //使用了margin-bottom 总是出现滑动条 用逻辑判断，多于5条设置scroll
					mainHolder.style.overflowY='scroll';
				}else{
					mainHolder.style.overflowY='hidden';
				}
				mainHolder.className = "deviceList";
			}else{
				tmpHtml={div:[]};
				for(var i=0,j,secLen,len=data.length;i<len;i++){ //组织sync list
					//window.console.log(JSON.stringify(data));
					tmp = data[i].data;
					secLen = tmp.data.length;
					tmpHtml.div[i]={attr:{'class':(i==syncLastOpen)?"syncListItem open":"syncListItem"}};
					tmpList = [];
					for(j=0;j<secLen;j++){ //收起来内容
						//tmpList.push('<a class="itemLink" href="'+tmp.data[j].url+'" target="_blank"><img src="'+self.bg.get_favico(tmp.data[j].url)+'"/>'+tmp.data[j].title+'</a>')
						tmpList[j]={attr:{'class':'itemLink','href':tmp.data[j].url,'target':'_blank'},inner:{img:{attr:{'src':self.bg.get_favico(tmp.data[j].url)}},'textNode':tmp.data[j].title}};
					}
					//tmpHtml.push('<div class="syncListItem '+((i==syncLastOpen)?"open":"")+'" ><span class="itemTitle" id="'+i+'">'+(tmp.name||'Silver Pc')+'</span><span class="itemHolder">'+tmpList.join("")+'</span></div>');//可见标题
					tmpHtml.div[i].inner={span:[{attr:{'class':'itemTitle',id:i},inner:tmp.name},{attr:{'class':'itemHolder'},inner:{a:tmpList}}]};
					//tmpHtml.div[i].inner.span[1].inner={};
					//tmpHtml.div[i].inner.span[1].inner.a=tmpList;
					//window.console.log(JSON.stringify(tmpHtml));
				}
				mainHolder.className = "syncList";
				mainHolder.style.overflowY='auto';
				//window.console.log(JSON.stringify(tmpHtml));
			}
			mainHolder.textContent = '';
			self.ff_createDom(mainHolder,tmpHtml);
			//mainHolder.innerHTML = tmpHtml.join('');
			if(curPage=='sync'){secAddListen();}//获取tab所有节点 在收缩展开时用到
			setTimeout(function(){self.resize(outerHolder.offsetWidth,outerHolder.offsetHeight)},50);
		}
		function showErr(tmpKind){
			/* var tmpCss = {
			'downDolphin':['someError downNewerDolphin',"<img src='images/secode.png'/><span>Download the most recent version of  Dolphin Browser on your mobile!</span>"],  //下载海豚
			'syncNoDevice':['someError syncNoDevice','<span>No tabs open in other devices!</span>'], //没有可同步设备
			'syncOpps':['syncOops','<p>Oops!</p>Open Tabs sync has been disabled. Please enable it in <a id="gotoSet">Settings</a> and try again.'], //禁用tab 
			'sentEmpty':['someError pushEmpty','<span><span></span>Cannot push blank tab!</span>'] //不可发送网址
			}; */
			var tmpCss = {
			'downDolphin':['someError downNewerDolphin',{img:{attr:{src:'images/secode.png'}},span:{inner:'Scan to get the latest Dolphin on your mobile. Or log in to Dolphin Connect to get started if you already have it.'}}],  //下载海豚
			'syncNoDevice':['someError syncNoDevice',{span:{inner:'No tabs open in other devices!'}}], //没有可同步设备
			'syncOpps':['syncOops',{p:{inner:'Oops!'},'textNode':'Open Tabs sync has been disabled. Please enable it in ',a:{attr:{id:'gotoSet'},inner:'Settings'},'textNode1':' and try again.'}], //禁用tab 
			'sentEmpty':['someError pushEmpty',{span:{inner:{span:{},'textNode':'Cannot push blank tab!'}}}] //不可发送网址
			};
			if(!(tmpKind in tmpCss)){return ;}
			mainHolder.className = tmpCss[tmpKind][0];
			mainHolder.textContent = '';
			self.ff_createDom(mainHolder,tmpCss[tmpKind][1]);
			//mainHolder.innerHTML = tmpCss[tmpKind][1];
			if(tmpKind=='downDolphin'){   //无设备显示下载海豚 viewOther 不可点击
				viewOtherTreat(false);
			}
			mainHolder.style.overflowY='hidden';
			setTimeout(function(){self.resize(outerHolder.offsetWidth,outerHolder.offsetHeight)},50);
		}
		function viewOtherTreat(method){
			enableViewOther = method; 
			self.$('viewOther').innerHTML = method?'cloud tabs':'refresh';
		}
		function handleClick(e){  //处理点击事件 主面板
			var tmpNode = e.target;
			if(tmpNode.id =='showUserInfo'||tmpNode.id=='gotoSet'){self.bg.open_userinfo_page(); win_close();return ;}  //点击帐号 打开设置页面
			if(tmpNode.id=='syncBookmark'){    
				if(!/disabled/.test(tmpNode.calssName)){
					self.sync_bookmark('doing');
					//添加同步书签操作
				}
				return ;
			}
			switch(curPage){
				case 'device':   
					if(tmpNode.id=="back"||tmpNode.id =='viewOther'){  //点击viewOther 
						enableViewOther?createPageDom(self.bg.CommInfo.tab_sync_list_sorted(),null,'sync'):self.bg.pushReConnect(true);
						return ;
					}
					if(/\bdeviceName\b|\bdeviceItemInner\b|\bdeviceShorcut\b|\bdeviceItem\b/.test(tmpNode.className)){
						tmpNode = tmpNode.parentNode;
						if(self.bg){win_close();self.bg.pushSend(tmpNode.id,null);}  //点击设备 发送
					}
				break;
				case 'sync':
					if(tmpNode.id=="back"||tmpNode.id =='viewOther'){  //点击back
						if(tmpNode.id=='back'){createPageDom(self.bg.GetPushDevicesSorted(),self.bg.CommInfo.get_device_shortcut(),'device');}
						return ;
					}
					if(tmpNode.className=='itemTitle'){  //在sync 点击展开 
						if(syncLastOpen == tmpNode.id){
							syncList[syncLastOpen].className = 'syncListItem';
							syncLastOpen = -1;
							self.resize(outerHolder.offsetWidth,outerHolder.offsetHeight)
							return ;
						}
						tmpNode.parentNode.className+=' open';
						if(syncList[syncLastOpen]){syncList[syncLastOpen].className = 'syncListItem'};//之前展开的收缩
						syncLastOpen = tmpNode.id;
						self.resize(outerHolder.offsetWidth,outerHolder.offsetHeight)
					}
				break;
				default:
				break;
			}
			
			
		}
	},
	setPaneInit:function(){   //设置页面处理逻辑
		var self=this,outerHolder,ShortCutList={},currentInput=null,trackCode={bookmark:['bookmarkson','bookmarksoff'],tab:['tabson','tabsoff'],dolphinBtn:['dolphinbutton','dolphinbutton'],pcName:'namechange',shortCut:'shortcutset'};
		addListen();
		function addListen(){  //监听事件
			if(!(mainHolder=self.$('setOuter'))){window.setTimeout(addListen,500);return ;}// 判断页面是否加载完成
			self.reflashDeviceName=function(tmpName){
				self.$('pcName').value = tmpName;
			}
			self.shortCutInit = function() {
                var self = this, data = self.bg.CommInfo.device_list, tmpShortCutList = (self.bg.CommInfo.get_device_shortcut && self.bg.CommInfo.get_device_shortcut());
                ShortCutList ={};
				if (data.length > 0) {
                    var tmpNode = self.$('shortCutHolder'), tmpHtml = {}, tmpKeys;
                    //tmpHtml.push('<span class="helpInfo">Click the box below to edit your shortcut</span>');
                    tmpHtml.span = {attr:{'class':'helpInfo'},inner:'Click the box below to edit your shortcut'};
					tmpHtml.div = [];
					for (var i = 0, len = data.length; i < len; i++) {
                        tmpKeys = (tmpShortCutList && tmpShortCutList[data[i].did]) ? (tmpShortCutList[data[i].did].join('+')) : "";
                        ShortCutList[data[i].did] = tmpKeys;  //保存已经用快捷键 控制重复
                        tmpHtml.div[i] = {attr:{'class':'shortCutItem ' + data[i].category},inner:{span:[{attr:{'class':'deviceName'},inner:data[i].deviceName},{attr:{'class':'shortCutKeys',id:data[i].did},inner:tmpKeys},{attr:{'class':'deleBtn'}}]}};
						//tmpHtml.push('<div class="shortCutItem ' + data[i].category + '"><span class="deviceName">' + (data[i].deviceName && data[i].deviceName.replace(/%20/, ' ')) + '</span><span class="shortCutKeys" id="' + data[i].did + '">' + tmpKeys + '</span><span class="deleBtn"></span></div>');
                    }
                    //tmpNode.innerHTML = tmpHtml.join('');
					tmpNode.textContent = '';
					self.ff_createDom(tmpNode,tmpHtml);
					
                } else {
                    var tmpNode = self.$('shortCutHolder');
                    tmpNode.textContent = '';
					self.ff_createDom(tmpNode,{div:{attr:{'class':'noDevice'},inner:'No devices connected!'}});
					//tmpNode.innerHTML = '<div class="noDevice">No devices connected!</div>';
                }
            }
			self.addEvent(self.$('cancle'),'click',function(){comfirmBox(false)});  //logout 退出按键
			self.addEvent(self.$('yes'),'click',function(){win_close();self.bg.logout();}) //logout 确定按键
			self.addEvent(mainHolder,'click',function(e){handleClick(e)});
			self.addEvent(document,'keydown',function(e){getKeys(e)}); //捕获用户按键
			self.addEvent(self.$('pcName'),'focus',function(){if(this.parentNode.className.indexOf('reName')==-1){this.parentNode.className+=" reName";}this.setAttribute('oldvalue',this.value)}); //rename PC name 
			self.addEvent(self.$('pcName'),'blur',function(){var tmpName = this.parentNode.className;this.parentNode.className=tmpName.replace(' reName','');if(this.value!=''&&self.bg.dev_rename){self.bg.dev_rename(null,this.value,null);self.bg.track_event({category:'general',action:'setting',label:trackCode['pcName'],value:1});}else{this.value=this.getAttribute('oldvalue')};});
			self.addEvent(window,'unload',function(){saveSetting('both')}); //退出时再保存一次
			self.addEvent(self.$('gotoAdvance'),'click',gotoAdvance); //in web manage
			showSetInfo();  //显示帐号相关信息
		}
		function showSetInfo(){
			var checkBoxs,localSetting;
			//self.$('nickName').textContent = self.bg.CommInfo.nick_name; // 显示 用户名
			self.$('userName').textContent = self.bg.CommInfo.nick_name; //帐号 
			self.$('accountKind').textContent = self.bg.CommInfo.login_typeName; //帐号类型
			self.$('pcName').value = self.bg.get_devicename();  //当前设备名称
			localSetting=self.bg.CommInfo.get_setting(); //获取本地缓存中的设置，
			if(localSetting){   //显示check 设置
				checkBoxs = self.$('.formCheck','querySelectorAll');
				if(checkBoxs.length>=3){
					if(localSetting['bookmark']){checkBoxs[0].className+=' checked';checkBoxs[0].childNodes[0].checked=true}
					if(localSetting['tab']){checkBoxs[1].className+=' checked';checkBoxs[1].childNodes[0].checked=true}
					if(localSetting['button']){checkBoxs[2].className+=' checked';checkBoxs[2].childNodes[0].checked=true}
				}
			}
			//设置快捷键之前状态
			self.shortCutInit();
		}
		function saveSetting(kind){ //保存设置 用kind可分开保存 避免无用的保存
			if(kind!='saveShort'){  //保存 本地设置
				var checkBoxs = self.$('.formCheck','querySelectorAll'),settings;
				settings = {bookmark:checkBoxs[0].childNodes[0].checked,tab:checkBoxs[1].childNodes[0].checked,button:checkBoxs[2].childNodes[0].checked}
				self.bg.CommInfo.save_setting(settings);
			}
			if(kind!='saveCheck'){ //保存快捷键
				var shortCutNList = self.$('.shortCutKeys','querySelectorAll'),tmpObj ={};
				for(i=0,len = shortCutNList.length;i<len;i++){
					if(shortCutNList[i].className.indexOf('input')!=-1){continue;}
					tmpObj[shortCutNList[i].id] = shortCutNList[i].textContent.split('+');
				}
				(self.bg.CommInfo.save_device_shortcut&&self.bg.CommInfo.save_device_shortcut(tmpObj));
			}
		}
		function shortCutExitCurrent(){ //退出快捷键编辑状态
			var tmpClass = currentInput.className;
			currentInput.className=tmpClass.replace(' input','');
			tmpClass=currentInput.parentNode.className;
			currentInput.parentNode.className=tmpClass.replace(' inputState','');
		}
		function comfirmBox(isShow){  //logout 对话框
			self.$('showCover').style.display=isShow?'block':'none';
			self.$('showConfirm').style.display=isShow?'block':'none';
		}
		function handleClick(e){ //页面大部分点击逻辑控制
			var tmpId = e.target.id,tmpN=e.target;
			if(tmpId == 'logout'){ //点logout
				comfirmBox(true);
				return ;
			}
			if(tmpN.className=="deleBtn"){var tmpP = tmpN.previousSibling;tmpP.textContent='';ShortCutList[tmpP.id] = "";saveSetting('saveShort')}//点 小X
			if(tmpN.className=='formCheck'){tmpN.className+=' checked';tmpN.childNodes[0].checked=true;saveSetting('saveCheck');self.bg.track_event({category:'general',action:'setting',label:trackCode[tmpN.childNodes[0].id][0],value:1});return ;}  //选择框加钩
			if(tmpN.className=='formCheck checked'){tmpN.className = 'formCheck';tmpN.childNodes[0].checked=false;saveSetting('saveCheck');self.bg.track_event({category:'general',action:'setting',label:trackCode[tmpN.childNodes[0].id][1],value:1});return ;} //选择框去钩
			if(tmpN.className=='shortCutKeys'){if(currentInput){shortCutExitCurrent();currentInput.textContent=currentInput.getAttribute('oldvalue');}tmpN.setAttribute('oldvalue',tmpN.textContent);tmpN.className+=' input';tmpN.parentNode.className+=' inputState';currentInput=tmpN;self.bg.track_event({category:'general',action:'setting',label:trackCode['shortCut'],value:1});return ;} //点击编辑快捷键
			if(currentInput){shortCutExitCurrent();currentInput.textContent=currentInput.getAttribute('oldvalue');currentInput=null;}
		}
		function getKeys(e){
			var keys = [],tmpShort;
			if(e.target.id=='pcName'){  //pcName rename 回车退出
				if(e.keyCode==13){e.target.blur();e.preventDefault();}
				if(e.target.value.replace(/[^\x00-\xff]/g,"**").length>20){e.preventDefault();}
				return ;
			}
			e.preventDefault();
			if(!currentInput){return;} //无快捷键输入框选中退出
			
			if(e.ctrlKey || e.shiftKey || e.altKey||e.metaKey){ //有前缀键按下，显示 但不保存 无前缀键 不予响应
				if(e.metaKey){
					keys.push('Cmd');
				}
				if(e.shiftKey) {
					keys.push('Shift');
				}
				if(e.ctrlKey){
					keys.push('Ctrl');
				}
				if(e.altKey) {
					keys.push('Alt');
				}
				if(e.which){
					keys.push(String.fromCharCode(e.which));
				}
			ShortCutList[currentInput.id] = "";
			keys = keys.join('+');
			tmpShort = JSON.stringify(ShortCutList);
			ShortCutList[currentInput.id]=keys;
			currentInput.textContent=keys;
			var tmpCode = e.keyCode;  //获取当前按下
			if((47<tmpCode&&tmpCode<58)||(64<tmpCode&&tmpCode<91)){ //当有非前缀键按下时判断是否重复 否保存 并退出编辑 是重复 提示重复 回复原值
				if(tmpShort.indexOf('"'+keys+'"')==-1){	
					shortCutExitCurrent();
					currentInput.setAttribute('oldvalue',currentInput.textContent)
					currentInput = null;
					saveSetting('saveShort');
				}else{
					alert('The shortcut has already existed, please choose another one.');
					currentInput.textContent =currentInput.getAttribute('oldvalue');
				}
			}
			}
		}
		function gotoAdvance(){
		var tempForm = document.createElement("form");    
	  
		 tempForm.id="tempForm1";    
	  
		 tempForm.method="post";    
	  
	  	 var manage_domain = 'https://sen.dolphin-browser.com';
	  	 if(self.bg.CommInfo.region_domain != null) {
	  	 	manage_domain = self.bg.CommInfo.region_domain;
	  	 }
		 tempForm.action= manage_domain+'/manage';  
	  
		 tempForm.target='_blank';    
	  
		
	  
		 var hideInput = document.createElement("input");    
	  
		 hideInput.type="hidden";    
	  
		 hideInput.name= "token";  
	  
		 hideInput.value= self.bg.CommInfo.token?self.bg.CommInfo.token:'e2abe33787d1487e9642072fb9ba9e13';  
	  
		 tempForm.appendChild(hideInput);     
	  
		 //tempForm.attachEvent("onsubmit",function(){ openWindow(name); });  
	  
		 document.body.appendChild(tempForm);     
	  
		 tempForm.submit();  
	  
		 document.body.removeChild(tempForm);  
		}
	},
	reflashDeviceName:function(){},
	shortCutInit: function() { },
	sync_bookmark: function() { },
	reflashPage:function(){},
	addEvent:function(tDom,eType,Func,other){
		if(!(tDom&&eType&&Func)){
			return null;
		}
		other = (other==undefined)?true:other;
		if(tDom.length>1){
			for(var i=0,len=tDom.length;i<len;i++){
				tDom[i].addEventListener(eType,Func,other)
			}
			return ;
		}
		tDom.addEventListener(eType,Func,other);
	},
	ff_createDom:function(p_dom,inObj){
		_createNode(p_dom,inObj);
		function _createNode(target_node,tmp_obj){
			var tmp;
			for(var i in tmp_obj){
				//window.console.log('createNode……'+i);
				if(i=='textNode'||i=='textNode1'){
					tmp = document.createTextNode(tmp_obj[i]);
				}else if(Object.prototype.toString.call(tmp_obj[i])=='[object Array]'){
					for(var j=0,len=tmp_obj[i].length;j<len;j++){
						tmp = document.createElement(i);
						if(tmp_obj[i][j].attr)
							tmp = _addAttr(tmp,tmp_obj[i][j].attr);
						if(tmp_obj[i][j].inner)
							tmp = _addInner(tmp,tmp_obj[i][j].inner);
						target_node.appendChild(tmp);
					}
					continue;
				}else{
					tmp = document.createElement(i);
					if(tmp_obj[i].attr)
						tmp = _addAttr(tmp,tmp_obj[i].attr);
					if(tmp_obj[i].inner)
						tmp = _addInner(tmp,tmp_obj[i].inner);
				}
				target_node.appendChild(tmp);
			}
			return target_node;
		}
		function _addAttr(target_node,tmp_obj){
			//window.console.log('addAttribute……'+JSON.stringify(tmp_obj));
			for(var i in tmp_obj){
				switch(i){
					case 'class':
						target_node.className = tmp_obj[i];
					break;
					case 'id':
						target_node.id = tmp_obj[i];
					break;
					default:
						target_node.setAttribute(i,tmp_obj[i]);
					break;
				}
			}
			return target_node;
		}
		function _addInner(target_node,tmp_inner){
			//window.console.log('addinner……'+JSON.stringify(tmp_inner));
			switch(typeof tmp_inner){
				case 'string':
					target_node.textContent = tmp_inner;
					return target_node;
				break;
				case 'object':
					return _createNode(target_node,tmp_inner);
				break;
			}
		}
	},
	resize:function(tmpW,tmpH){
		tmpW = tmpW+3;
		self.port.emit("message",{type:'display',msg:{width:tmpW,height:tmpH}});
		//window.console.log('resize'+tmpW+':'+tmpH);
	},
	$:function(id,kind){  //kind 用于自定义获取方法
		if(kind){return document[kind](id);}
		return (Object.prototype.toString.call(id)=='[objec Array]')?document.querySelectorAll(id.join(',')):((typeof id =='string')?document.getElementById(id):null);
	}
}
//var demo = new SyncFontEnd();
