exports.API = function(){return API};
exports.DOMAIN_ID_CHECK  = DOMAIN_ID_CHECK;

var CommInfo = require("./common").CommInfo();

var DOMAIN_ID = "https://sen.dolphin-browser.com/";
var DOMAIN_ID_CHECK = ["http://sen.dolphin-browser.com/","https://sen.dolphin-browser.com/"];
var DOMAIN_SYNC = "https://sen.dolphin-browser.com";
var DOMAIN_PUSH = "https://pushservice.dolphin-browser.com";
var DOMAIN_SONAR = "http://vcen.dolphin-browser.com/";

var API={
	signup:DOMAIN_ID + "accounts/signup/",
	auth:DOMAIN_ID + "api/2/user/auth",
	info:DOMAIN_ID + "api/2/user/info",
	loginresult:[DOMAIN_ID_CHECK[0] + "accounts/2/loginresult",DOMAIN_ID_CHECK[1] + "accounts/2/loginresult"],
	//logout:DOMAIN_ID + "api/2/user/logout",
	validate_token:DOMAIN_ID + "api/2/user/validatetoken",
	
	sync_create:function() { 
		if(CommInfo.region_domain) {
			return CommInfo.region_domain + "/api/1/sync/create";
		}
		else {
			return DOMAIN_SYNC + "/api/1/sync/create"; 
		}
	},
	sync_update: function() {
		if(CommInfo.region_domain) {
			return CommInfo.region_domain + "/api/1/sync/update";
		}
		else {
			return DOMAIN_SYNC + "/api/1/sync/update";
		}
	},
	sync_getchunk: function() {
		if(CommInfo.region_domain) {
			return CommInfo.region_domain + "/api/1/sync/getchunk";
		}
		else {
			return DOMAIN_SYNC + "/api/1/sync/getchunk";
		}
	},
	sync_state: function() {
		if(CommInfo.region_domain) {
			return CommInfo.region_domain + "/api/1/sync/state";
		}
		else {
			return DOMAIN_SYNC + "/api/1/sync/state";
		}
	},
	sonar_command:DOMAIN_SONAR+"api/voice/1/getPhrase",
	sonar_query:DOMAIN_SONAR+"api/1/sonarconnect/query_connect",
	
	logout: function() {
		if(CommInfo.push_domain) {
			return CommInfo.push_domain + "/data/1/device/logout";
		}
		else {
			return DOMAIN_PUSH + "/data/1/device/logout";	
		}
	}
};
